<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE xsl:stylesheet [ <!ENTITY nbsp "&#160;"> ]>
<xsl:stylesheet version="2.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
   xmlns="http://www.w3.org/1999/xhtml"
    xmlns:html="http://www.w3.org/1999/xhtml" exclude-result-prefixes="html">

  <xsl:output method="html" omit-xml-declaration="no" indent="yes"/>

  <xsl:template match="node()">
    <xsl:copy>
      <xsl:apply-templates/>
    </xsl:copy>
  </xsl:template>

  <xsl:template match="//*[@id='frontend-list']">
    <xsl:call-template name="modulelist">
      <xsl:with-param name="modtype">frontend</xsl:with-param>
    </xsl:call-template>
  </xsl:template>

  <xsl:template match="//*[@id='backend-list']">
    <xsl:call-template name="modulelist">
      <xsl:with-param name="modtype">backend</xsl:with-param>
    </xsl:call-template>
  </xsl:template>

  <xsl:template name="modulelist">
    <xsl:param name="modtype"/>
    <xsl:for-each select="document('modules.xml')//modules/node()">
      <xsl:if test=".[@type=$modtype]">
        <xsl:variable name="file" select="./text()"/>
        <xsl:variable name="doc" select="concat('../site/xhtml5/mod/',$file, '.xhtml5')"/>
        <xsl:variable name="description" select="document($doc)/html:html/html:head/html:meta[@name='description']/@content"/>
        <dt><a href="mod/{$file}.html"><xsl:copy-of select="$file"/></a></dt><dd><p><xsl:value-of select="$description"/></p></dd>
      </xsl:if>
    </xsl:for-each>
  </xsl:template>
</xsl:stylesheet>
